// Crack shader

#version 450

//

layout(triangles) in;
layout(triangle_strip, max_vertices = 3) out;

in vec2 texCoord[3];   //[3] because this makes a triangle
in vec3 exNormal[3];
out vec2 texCoordG;
out vec3 exNormalG;

void main()
{
  vec4 middleOfTriangle = vec4(0.0);
  
  for(int i = 0; i < gl_in.length(); i++)
  {
    middleOfTriangle += gl_in[i].gl_Position;
  }
  middleOfTriangle /= gl_in.length();

  for(int i = 0; i < gl_in.length(); i++)
  {
    gl_Position = (gl_in[i].gl_Position + middleOfTriangle) / 2.0;
    texCoordG = texCoord[i];
    exNormalG = exNormal[i];
    EmitVertex();
  }
  EndPrimitive();
}
